/***************************************************
  Copyright (c) : HuangHuijuan from LNSF_AIoT on 2022/07/20.
 ****************************************************/

#include <LNSFAIoT_RS485_air_quality_sensor.h>

int LNSFAIoT_list_SerialDataair[14];
unsigned int LNSFAIoT_air_num_PM10, LNSFAIoT_air_num_CO2, LNSFAIoT_air_num_CH2O, LNSFAIoT_air_num_TVOC, LNSFAIoT_air_num_PM25;
float LNSFAIoT_air_num_WenDu, LNSFAIoT_air_num_ShiDu;
int32_t wenurxun[8] = {0x01, 0x03, 0x00, 0x02, 0x00, 0x07, 0xA5, 0xC8};
int addr = 1;

void LNSFAIoT_RS485_air_quality_sensor::begin(HardwareSerial *serial, int rx, int tx, int bo,int addr)
{
    delay(1000);
    serialH = serial;
    mySerial = serialH;
#if defined(__AVR__) || defined(ESP8266) || defined(FREEDOM_E300_HIFIVE1)
    serialS = NULL;
#endif

#if defined NRF5
    rx = g_PinID[rx];
    tx = g_PinID[tx];
    MicroBitPin *rxpin = getMicroBitPin(rx);
    MicroBitPin *txpin = getMicroBitPin(tx);
    uBit.serial.redirect(txpin->name, rxpin->name);
    uBit.serial.setRxBufferSize(64);
    serialH->begin(bo);
#elif defined ESP_PLATFORM
    serialH->begin(bo, rx, tx);
#else
    serialH->begin(bo);
#endif

switch (addr)
    {
    case 1:
        // int32_t wenurxun[8] = {0x01, 0x03, 0x00, 0x02, 0x00, 0x07, 0xA5, 0xC8};

        wenurxun[0] = 0x01;
        wenurxun[6] = 0xA5;
        wenurxun[7] = 0xC8;
        break;
    case 2:
        // wenurxun[8] = {0x02, 0x03, 0x00, 0x02, 0x00, 0x07, 0xA5, 0xFB};
        wenurxun[0] = 0x02;
        wenurxun[6] = 0xA5;
        wenurxun[7] = 0xFB;
        break;
    case 3:
        // wenurxun[8] = {0x03, 0x03, 0x00, 0x02, 0x00, 0x07, 0xA4, 0x2A};
        wenurxun[0] = 0x03;
        wenurxun[6] = 0xA4;
        wenurxun[7] = 0x2A;
        break;
    case 4:
        // wenurxun[8] = {0x04, 0x03, 0x00, 0x02, 0x00, 0x07, 0xA5, 0x9D};
        wenurxun[0] = 0x04;
        wenurxun[6] = 0xA5;
        wenurxun[7] = 0x9D;
        break;
    case 5:
        // int32_t wenurxun[8] = {0x05, 0x03, 0x00, 0x02, 0x00, 0x07, 0xA4, 0x4C};
        wenurxun[0] = 0x05;
        wenurxun[6] = 0xA4;
        wenurxun[7] = 0x4C;
        break;
    case 6:
        // int32_t wenurxun[8] = {0x06, 0x03, 0x00, 0x02, 0x00, 0x07, 0xA4, 0x7F};

        wenurxun[0] = 0x06;
        wenurxun[6] = 0xA4;
        wenurxun[7] = 0x7F;
        break;
    case 7:
        // int32_t wenurxun[8] = {0x07, 0x03, 0x00, 0x02, 0x00, 0x07, 0xA5, 0xAE};
        wenurxun[0] = 0x07;
        wenurxun[6] = 0xA5;
        wenurxun[7] = 0xAE;
        break;
    default:
        break;
    }

}

#if defined(__AVR__) || defined(ESP8266) || defined(FREEDOM_E300_HIFIVE1)
void LNSFAIoT_RS485_air_quality_sensor::begin(SoftwareSerial *serial, int bo,int addr)
{
    delay(1000);
    serialS = serial;
    mySerial = serialS;
    serialH = NULL;
    serialS->begin(bo);

    switch (addr)
    {
    case 1:
        wenurxun[0] = 0x01;
        wenurxun[6] = 0xA5;
        wenurxun[7] = 0xC8;
        break;
    case 2:
        wenurxun[0] = 0x02;
        wenurxun[6] = 0xA5;
        wenurxun[7] = 0xFB;
        break;
    case 3:
        wenurxun[0] = 0x03;
        wenurxun[6] = 0xA4;
        wenurxun[7] = 0x2A;
        break;
    case 4:
        wenurxun[0] = 0x04;
        wenurxun[6] = 0xA5;
        wenurxun[7] = 0x9D;
        break;
    case 5:
        wenurxun[0] = 0x05;
        wenurxun[6] = 0xA4;
        wenurxun[7] = 0x4C;
        break;
    case 6:
        wenurxun[0] = 0x06;
        wenurxun[6] = 0xA4;
        wenurxun[7] = 0x7F;
        break;
    case 7:
        wenurxun[0] = 0x07;
        wenurxun[6] = 0xA5;
        wenurxun[7] = 0xAE;
        break;
    default:
        break;
    }

}
#endif

void LNSFAIoT_RS485_air_quality_sensor::LNSFAIoT_air_quality_sensor_RS485analysis(void)
{
    for (int i = 0; i < 8; i++)
    {
        mySerial->write(wenurxun[i]);
    }

    if (mySerial->available())
    {
        if ((mySerial->read() == addr) && (mySerial->read() == 3) && (mySerial->read() == 14))
        {
            for (int i = 0; i < 14; i++)
            {
                LNSFAIoT_list_SerialDataair[i] = mySerial->read();
            }
            LNSFAIoT_air_num_CO2 = (String(LNSFAIoT_list_SerialDataair[0]).toFloat()) * 256 + String(LNSFAIoT_list_SerialDataair[1]).toFloat();
            LNSFAIoT_air_num_CH2O = (String(LNSFAIoT_list_SerialDataair[2]).toInt()) * 256 + String(LNSFAIoT_list_SerialDataair[3]).toInt();
            LNSFAIoT_air_num_TVOC = (String(LNSFAIoT_list_SerialDataair[4]).toInt()) * 256 + String(LNSFAIoT_list_SerialDataair[5]).toInt();
            LNSFAIoT_air_num_PM25 = (String(LNSFAIoT_list_SerialDataair[6]).toFloat()) * 256 + String(LNSFAIoT_list_SerialDataair[7]).toFloat();
            LNSFAIoT_air_num_PM10 = (String(LNSFAIoT_list_SerialDataair[8]).toFloat()) * 256 + String(LNSFAIoT_list_SerialDataair[9]).toFloat();
            LNSFAIoT_air_num_WenDu = ((String(LNSFAIoT_list_SerialDataair[10]).toFloat()) * 256 + (String(LNSFAIoT_list_SerialDataair[11]).toFloat())) * 0.1;
            LNSFAIoT_air_num_ShiDu = ((String(LNSFAIoT_list_SerialDataair[12]).toFloat()) * 256 + (String(LNSFAIoT_list_SerialDataair[13]).toFloat())) * 0.1;
        }
    }
    delay(1000);
}

void LNSFAIoT_RS485_air_quality_sensor::LNSFAIoT_air_quality_sensor_RS485println(void)
{
    Serial.println("湿度: " + String(LNSFAIoT_air_num_ShiDu) + " %");
    Serial.println("温度: " + String(LNSFAIoT_air_num_WenDu) + " ℃");
    Serial.println("PM10: " + String(LNSFAIoT_air_num_PM10) + " ug/m3");
    Serial.println("CO2: " + String(LNSFAIoT_air_num_CO2) + " ppm");
    Serial.println("CH2O: " + String(LNSFAIoT_air_num_CH2O) + " ug/m3");
    Serial.println("TVOC: " + String(LNSFAIoT_air_num_TVOC) + " ug/m3");
    Serial.println("PM2.5: " + String(LNSFAIoT_air_num_PM25) + " ug/m3");
}

float LNSFAIoT_RS485_air_quality_sensor::LNSFAIoT_air_num_ShiDu_RS485func(void)
{
    return LNSFAIoT_air_num_ShiDu;
}

float LNSFAIoT_RS485_air_quality_sensor::LNSFAIoT_air_num_WenDu_RS485func(void)
{
    return LNSFAIoT_air_num_WenDu;
}

int LNSFAIoT_RS485_air_quality_sensor::LNSFAIoT_air_num_PM10_RS485func(void)
{
    return LNSFAIoT_air_num_PM10;
}

int LNSFAIoT_RS485_air_quality_sensor::LNSFAIoT_air_num_CO2_RS485func(void)
{
    return LNSFAIoT_air_num_CO2;
}

int LNSFAIoT_RS485_air_quality_sensor::LNSFAIoT_air_num_CH2O_RS485func(void)
{
    return LNSFAIoT_air_num_CH2O;
}

int LNSFAIoT_RS485_air_quality_sensor::LNSFAIoT_air_num_TVOC_RS485func(void)
{
    return LNSFAIoT_air_num_TVOC;
}

int LNSFAIoT_RS485_air_quality_sensor::LNSFAIoT_air_num_PM25_RS485func(void)
{
    return LNSFAIoT_air_num_PM25;
}
