/***************************************************
  Written by HuangHuijuan from LNSF_AIoT on 2022/07/14.
 ****************************************************/
#ifndef _LNSFAIOT_RS485_AIR_QUALITY_SERSOR
#define _LNSFAIOT_RS485_AIR_QUALITY_SERSOR

#include "Arduino.h"
#if defined(__AVR__) || defined(ESP8266) || defined(FREEDOM_E300_HIFIVE1)
#include <SoftwareSerial.h>
#endif

#if ARDUINO >= 100
#define SERIAL_WRITE(...) mySerial->write(__VA_ARGS__)
#else
#define SERIAL_WRITE(...) mySerial->write(__VA_ARGS__, BYTE)
#endif

#define SERIAL_WRITE_U16(v)        \
  SERIAL_WRITE((uint8_t)(v >> 8)); \
  SERIAL_WRITE((uint8_t)(v & 0xFF));

class LNSFAIoT_RS485_air_quality_sensor
{

public:
  void begin(HardwareSerial *serial, int rx, int tx, int bo,int addr);
#if defined(__AVR__) || defined(ESP8266) || defined(FREEDOM_E300_HIFIVE1)
  void begin(SoftwareSerial *serial, int bo,int addr);
#endif
void LNSFAIoT_air_quality_sensor_RS485analysis(void);
void LNSFAIoT_air_quality_sensor_RS485println(void);
float LNSFAIoT_air_num_ShiDu_RS485func(void);
float LNSFAIoT_air_num_WenDu_RS485func(void);
int LNSFAIoT_air_num_PM10_RS485func(void);
int LNSFAIoT_air_num_CO2_RS485func(void);
int LNSFAIoT_air_num_CH2O_RS485func(void);
int LNSFAIoT_air_num_TVOC_RS485func(void);
int LNSFAIoT_air_num_PM25_RS485func(void);

private:
#if defined(__AVR__) || defined(ESP8266) || defined(FREEDOM_E300_HIFIVE1)
  SoftwareSerial *serialS;
#endif
  HardwareSerial *serialH;
  Stream *mySerial;
  
};
#endif
