enum topics {
  //% block="Topic_0"
  topic_0,
  //% block="Topic_1"
  topic_1,
  //% block="Topic_2"
  topic_2,
  //% block="Topic_3"
  topic_3,
  //% block="Topic_4"
  topic_4
}
//% color="#3A5FEE" iconWidth=50 iconHeight=40
namespace aliyunjson {


  //% block=" 用户标识 [user] 上报[json]" blockType="reporter"
  //% user.shadow="string" user.defl=LNSF_AIoT
  //% json.shadow="string"  json.defl=键值对
  export function mqtt_post(parameter: any, block: any) {
    let json = parameter.json.code;
    let user = parameter.user.code;
    Generator.addObject(`my6e`, `String`, `LNSFAIoT_ClientID;`);
    Generator.addSetup(`my7e`, `LNSFAIoT_ClientID=${user};`);
    Generator.addCode(`("{\\"id\\":\\""+LNSFAIoT_ClientID+"\\",\\"params\\":{\\""+${json}+"},\\"method\\":\\"thing.event.property.post\\"}").c_str()`);
    // user = user.replace(/^\"|\"$/g, '');
    // Generator.addCode(`("{\\"id\\":\\""+${user}+"\\",\\"params\\":{\\""+${json}+"},\\"method\\":\\"thing.event.property.post\\"}").c_str()`);
  }


  //% block=" json键值对:  [lable] 值 [values] " blockType="reporter"
  //% lable.shadow="string" lable.defl=标识符
  //% values.shadow="reporter"
  //% values.shadow="number"  values.defl=1
  export function lable_values(parameter: any, block: any) {
    let lable = parameter.lable.code;
    let values = parameter.values.code;

    Generator.addCode(`${lable}+"\\":"+${values}`);
  }

  //% block=" [val1] 和 [val2] " blockType="reporter"
  //% val1.shadow="string" val1.defl=键值对
  //% val1.shadow="string"  val2.defl=键值对
  export function val_val(parameter: any, block: any) {
    let val1 = parameter.val1.code;
    let val2 = parameter.val2.code;
    Generator.addCode(`${val1}+",\\""+${val2}`);
  }



  //% block="获取返回的阿里云json:[aliyunew]中标识符[aliyunvalues]的值 " blockType="reporter"
  //% aliyunew.shadow="string" aliyunew.defl=阿里云MQTT消息
  //% aliyunvalues.shadow="string"  aliyunvalues.defl=标识符
  export function aliyunew_values(parameter: any, block: any) {
    let aliyunew = parameter.aliyunew.code;
    let aliyunvalues = parameter.aliyunvalues.code;
    Generator.addInclude('ArduinoJson', '#include <ArduinoJson.h>');
    Generator.addObject(`jsonBuffer`, `DynamicJsonBuffer`, `lnsfaiotjson;`);
    Generator.addCode(`lnsfaiotjson.parseObject(${aliyunew})["params"][${aliyunvalues}]`);

  }
}